#define SREAL
#include "atlas_misc.h"
void ATL_supMBmm6_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm12_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm18_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm24_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm30_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm36_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm42_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm48_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supMBmm54_6_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_sgpMBmm_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_spMBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[60] = 
   {
      NULL,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm6_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm12_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm18_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm24_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm30_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm36_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm42_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm48_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_supMBmm54_6_1_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0,
      ATL_sgpMBmm_b0
   };

   mmfunc[M](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
