#define DCPLX
#include "atlas_misc.h"
void ATL_zupMBmm6_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm12_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm18_6_1_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm0_4_0_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zgpMBmm_b0
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm6_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm12_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm18_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm0_4_0_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zgpMBmm_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm6_6_1_bX
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm12_6_1_bX
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm18_6_1_bX
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zupMBmm0_4_0_bX
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_zgpMBmm_bX
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);

static void ATL_ZupMBmm6_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{
   const double *rA = A + lda*M, *rB = B + ldb*N;
   ATL_zupMBmm6_6_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm6_6_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_zupMBmm6_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm6_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_ZupMBmm12_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{
   const double *rA = A + lda*M, *rB = B + ldb*N;
   ATL_zupMBmm12_6_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm12_6_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_zupMBmm12_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm12_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_ZupMBmm18_6_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{
   const double *rA = A + lda*M, *rB = B + ldb*N;
   ATL_zupMBmm18_6_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm18_6_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_zupMBmm18_6_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm18_6_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_ZupMBmm0_4_0_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{
   const double *rA = A + lda*M, *rB = B + ldb*N;
   ATL_zupMBmm0_4_0_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm0_4_0_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_zupMBmm0_4_0_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_zupMBmm0_4_0_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_zpMBmm_b1
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[20] = 
   {
      NULL,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm0_4_0_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm6_6_1_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm0_4_0_b1,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm12_6_1_b1,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm0_4_0_b1,
      ATL_zgpMBmm_b1,
      ATL_ZupMBmm18_6_1_b1,
      ATL_zgpMBmm_b1
   };

   mmfunc[M](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
